package sygr3emif;

import java.util.ArrayList;

import sygr.pots.extensions.ExtAlert;
import sygr.pots.extensions.PluginData;
import sygr.pots.extensions.PluginInterface;
import sygr.pots.extensions.PluginUtilInterface;
import sygr3em.model.MeasurementCalcResult;
import sygr3em.model.SingleTelemetry;

public class OutCalculationProblem implements PluginInterface {

	@Override
	public void execute(PluginData data, PluginUtilInterface util) {
		
		// First test: just send a mail
		ExtAlert alert = new ExtAlert();
		
		// Try to get the missing info
		SingleTelemetry st = new SingleTelemetry(); 
		MeasurementCalcResult mcr = new MeasurementCalcResult("");
		String oldstatus = "";
		if(!(data.transfer == null && data.transfer.size() > 0)) {
			for(Object oo: data.transfer) {
				if(oo instanceof SingleTelemetry) st = ( SingleTelemetry ) oo;
				if(oo instanceof MeasurementCalcResult ) mcr = ( MeasurementCalcResult ) oo;
				if(oo instanceof String ) oldstatus = ( String ) oo;
			}
		}
		
		alert.setAlertseverity(mcr.getSeverity());
		alert.setAlerttarget("SYSTEM");
		alert.setAlertsubject("Calculation problem - EXTERNAL PLUGIN");
		String text = "Object type: " + data.pot.getType() + System.lineSeparator();
		text = text + "Status: " + mcr.getStatus()  + System.lineSeparator();
		text = text + "ID: " + data.pot.getMatchkey0() + " = " + data.pot.getMatchval0() + System.lineSeparator();
		text = text + "Measurement: " + st.getC12c() + " = " + String.valueOf(st.getValue()) + st.getUom() + System.lineSeparator(); 
		text = text + "Message: " + mcr.getMessage() + System.lineSeparator();
		text = text + "Old status: " + oldstatus;
		alert.setAlerttext(text);
		util.sendAlert(alert);
		
	}

	@Override
	public void reloadConfig(ArrayList<String> changes, PluginUtilInterface util) {}

}
